SystemOrganization addCategory: #'CodA-Kernel'!
SystemOrganization addCategory: #'CodA-Tests'!

!ClassBuilder methodsFor: '*CodA' stamp: 'je 12/5/2007 16:03'!
newAnonymSubclassOf: newSuper type: type instanceVariables: instVars from: oldClass
	"Create a new subclass of the given superclass with the given specification."
	"WARNING: This method does not preserve the superclass/subclass invariant!!"
	| newFormat newClass |
	"Compute the format of the new class"
	newFormat := 
		self computeFormat: type 
			instSize: instVars size 
			forSuper: newSuper 
			ccIndex: (oldClass ifNil:[0] ifNotNil:[oldClass indexIfCompact]).

	newFormat == nil ifTrue:[^nil].

	(oldClass == nil or:[oldClass isMeta not]) 
		ifTrue:[newClass := self privateNewSubclassOf: newSuper from: oldClass]
		ifFalse:[newClass := oldClass clone].

	newClass 
		superclass: newSuper
		methodDictionary: MethodDictionary new
		format: newFormat;
		setInstVarNames: instVars.

	oldClass ifNotNil:[
		newClass organization: oldClass organization.
		"Recompile the new class"
		oldClass hasMethods 
			ifTrue:[newClass compileAllFrom: oldClass].

		oldClass hasTraitComposition ifTrue: [
			newClass setTraitComposition: oldClass traitComposition copyTraitExpression ].
		oldClass class hasTraitComposition ifTrue: [
			newClass class setTraitComposition: oldClass class traitComposition copyTraitExpression ].
		
		self recordClass: oldClass replacedBy: newClass.
	].

	^newClass! !

Object subclass: #CodAMeta
	instanceVariableNames: 'anonymClass oldObject metaComponents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodA-Kernel'!

!CodAMeta class methodsFor: 'as yet unclassified' stamp: 'mab 2/4/2008 17:38'!
initialize
	Smalltalk recreateCodASpecialObjectsArray.
	VariableNode initialize.
	Compiler recompileAll. ! !

!CodAMeta class methodsFor: 'as yet unclassified' stamp: 'je 1/18/2008 18:24'!
standardComponent
	^CodAMetaStandardComponent! !

!CodAMeta class methodsFor: 'as yet unclassified' stamp: 'mab 1/27/2008 21:22'!
with: anonymClass
	^self new anonymClass: anonymClass! !

!CodAMeta methodsFor: 'accessing' stamp: 'mab 11/8/2007 17:13'!
accept
	^ self componentAt: #Accept! !

!CodAMeta methodsFor: 'accessing' stamp: 'mab 1/18/2008 15:35'!
anonymClass
	^ anonymClass! !

!CodAMeta methodsFor: 'accessing' stamp: 'mab 1/18/2008 15:35'!
anonymClass: anObject
	anonymClass := anObject! !

!CodAMeta methodsFor: 'as yet unclassified' stamp: 'mab 11/8/2007 16:12'!
asExtendableMetaFor: anObject
	^self! !

!CodAMeta methodsFor: 'as yet unclassified' stamp: 'mab 11/8/2007 17:12'!
componentAt: aSelector
	^ metaComponents at: aSelector! !

!CodAMeta methodsFor: 'as yet unclassified' stamp: 'mab 11/8/2007 17:12'!
componentAt: aSelector put: aComponent
	^ metaComponents at: aSelector put: aComponent! !

!CodAMeta methodsFor: 'accessing' stamp: 'mab 11/8/2007 17:14'!
configuration
	^ self componentAt: #Configuration! !

!CodAMeta methodsFor: 'accessing' stamp: 'mab 11/8/2007 17:13'!
execution
	^ self componentAt: #Execution! !

!CodAMeta methodsFor: 'as yet unclassified' stamp: 'mab 1/18/2008 15:52'!
initialize
	metaComponents := Dictionary new.
	self componentAt: #Protocol put: self class standardComponent.
	self componentAt: #State put: self class standardComponent.
	self componentAt: #Accept put: self class standardComponent.
	self componentAt: #Send put: self class standardComponent.
	self componentAt: #Receive put: self class standardComponent.
	self componentAt: #Execution put: self class standardComponent.
	self componentAt: #Queue put: self class standardComponent.! !

!CodAMeta methodsFor: 'as yet unclassified' stamp: 'je 1/25/2008 17:01'!
install: aComponent at: aSymbol for: anObject
	self componentAt:  aSymbol put: aComponent.
	aComponent installingOn: aSymbol for: anObject! !

!CodAMeta methodsFor: 'as yet unclassified' stamp: 'mab 11/8/2007 16:16'!
isExtendableMeta
	^true! !

!CodAMeta methodsFor: 'accessing' stamp: 'mab 1/29/2008 11:42'!
newAnonymSubclassWithVariables: aSetOfVariables
	self anonymClass: (ClassBuilder new
		newAnonymSubclassOf: CodAAnonymClass
		type: CodAAnonymClass typeOfClass
		instanceVariables: aSetOfVariables
		from: nil).
	self anonymClass meta: self oldObject class.! !

!CodAMeta methodsFor: 'accessing' stamp: 'je 1/18/2008 18:25'!
oldObject
	^ oldObject! !

!CodAMeta methodsFor: 'accessing' stamp: 'mab 1/28/2008 00:01'!
oldObject: anObject
	oldObject := anObject.
	self anonymClass meta: self oldObject class.! !

!CodAMeta methodsFor: 'accessing' stamp: 'mab 11/8/2007 17:13'!
protocol
	^ self componentAt: #Protocol! !

!CodAMeta methodsFor: 'accessing' stamp: 'mab 11/8/2007 17:13'!
queue
	^ self componentAt: #Queue! !

!CodAMeta methodsFor: 'accessing' stamp: 'mab 11/8/2007 17:13'!
receive
	^ self componentAt: #Receive! !

!CodAMeta methodsFor: 'accessing' stamp: 'mab 11/8/2007 17:13'!
send
	^ self componentAt: #Send! !

!CodAMeta methodsFor: 'accessing' stamp: 'mab 11/8/2007 17:12'!
state
	^ self componentAt: #State! !

!CodAMeta methodsFor: 'accessing' stamp: 'mab 1/31/2008 17:51'!
switchToAnonymClass: anObject
	| newObject |
	newObject := self anonymClass new.
	newObject meta: self.
	anObject become: newObject.
	"anObject and newObject now switched"
	^newObject! !

Object subclass: #CodAMetaComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodA-Kernel'!

CodAMetaComponent subclass: #CodAMetaStandardComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodA-Kernel'!

!CodAMetaStandardComponent class methodsFor: 'as yet unclassified' stamp: 'mab 1/28/2008 01:46'!
methodFor: aMessage for: anObject
	^anObject meta oldObject class methodFor: aMessage for: anObject! !

!CodAMetaStandardComponent class methodsFor: 'as yet unclassified' stamp: 'mab 2/4/2008 16:06'!
receive: aMessage for: anObject
	| method result |
	method := anObject meta protocol methodFor: aMessage for: anObject.
	method ifNil: [ MessageNotUnderstood new 
		messageText: 'A CodA object received the message ', aMessage selector asExplorerString;
		receiver: anObject;
		message: aMessage;
		signal ].
	method isPrimitive ifTrue: [ 
		result := method 
			valueWithReceiver: anObject meta oldObject 
			arguments: aMessage arguments] ifFalse: [ 
		result := method 
			valueWithReceiver: anObject 
			arguments: aMessage arguments].
	^ result! !

!CodAMetaStandardComponent class methodsFor: 'as yet unclassified' stamp: 'mab 1/28/2008 14:30'!
send: aMessage for: anObject
	^ aMessage to meta receive receive: aMessage for: aMessage to! !

Object subclass: #CodATestObject
	instanceVariableNames: 'wauzi blub'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodA-Tests'!

!CodATestObject methodsFor: 'nil' stamp: 'mab 1/28/2008 17:08'!
changeSomething
	blub := 42.
	wauzi := 'Sinn des Lebens'.! !

Object subclass: #M
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodA-Kernel'!

!M class methodsFor: 'as yet unclassified' stamp: 'mab 12/5/2007 14:38'!
b
	^ CodAMessageBuilder new! !

!Object methodsFor: '*CodA' stamp: 'mab 12/5/2007 14:59'!
!!!! aMessage
	^ self meta send sendAsync: aMessage for: self! !

!Object methodsFor: '*CodA' stamp: 'mab 12/5/2007 14:57'!
<!! aMessage
	^ self meta send sendFuture: aMessage for: self! !

!Object methodsFor: '*CodA' stamp: 'je 1/26/2008 14:39'!
<* aMessage
	^ self meta receive receive: aMessage for: self! !

!Object methodsFor: '*CodA' stamp: 'mab 12/5/2007 14:49'!
<> aMessage
	^ self meta send sendSync: aMessage for: self! !

!Object methodsFor: '*CodA' stamp: 'mab 1/28/2008 17:40'!
asCodAObject
	^ self class asExtendableMetaFor: self! !

!Object methodsFor: '*CodA' stamp: 'mab 1/27/2008 20:59'!
hasExtendableMeta
	^false! !

!Object methodsFor: '*CodA' stamp: 'je 1/25/2008 17:48'!
meta
	^self class! !

!Object methodsFor: '*CodA' stamp: 'mab 1/31/2008 17:46'!
wrappedByCodA
	| meta object |
	meta := CodAMeta with: CodAAnonymClass.
	meta newAnonymSubclassWithVariables: self class instVarNames, #('codAMeta', 'codAExtension').
	meta anonymClass compileExtendedInstVarAccessors.
	object := meta anonymClass new.
	object meta: meta.
	meta oldObject: self.
	^ object! !

!SystemDictionary methodsFor: '*CodA' stamp: 'mab 2/4/2008 17:37'!
recreateCodASpecialObjectsArray
	"Smalltalk recreateSpecialObjectsArray"
	"The Special Objects Array is an array of object pointers used
	by the
	Squeak virtual machine. Its contents are critical and
	unchecked, so don't even think of playing here unless you
	know what you are doing."
	| newArray |
	newArray := Array new: 50.
	"Nil false and true get used throughout the interpreter"
	newArray at: 1 put: nil.
	newArray at: 2 put: false.
	newArray at: 3 put: true.
	"This association holds the active process (a ProcessScheduler)"
	newArray
		at: 4
		put: (self associationAt: #Processor).
	"Numerous classes below used for type checking and
	instantiation"
	newArray at: 5 put: Bitmap.
	newArray at: 6 put: SmallInteger.
	newArray at: 7 put: ByteString.
	newArray at: 8 put: Array.
	newArray at: 9 put: Smalltalk.
	newArray at: 10 put: Float.
	newArray at: 11 put: MethodContext.
	newArray at: 12 put: BlockContext.
	newArray at: 13 put: Point.
	newArray at: 14 put: LargePositiveInteger.
	newArray at: 15 put: Display.
	newArray at: 16 put: Message.
	newArray at: 17 put: CompiledMethod.
	newArray
		at: 18
		put: (self specialObjectsArray at: 18).
	"(low space Semaphore)"
	newArray at: 19 put: Semaphore.
	newArray at: 20 put: Character.
	newArray at: 21 put: #doesNotUnderstand:.
	newArray at: 22 put: #cannotReturn:.
	"The process that signaled the low space semaphore."
	newArray at: 23 put: nil.
	"An array of the 32 selectors that are compiled as special
	bytecodes, paired alternately with the number of arguments
	each takes."
	newArray at: 24 put: #(#+ 1 #- 1 #< 1 #> 1 #<= 1 #>= 1 #= 1 #~= 1 #* 1 #/ 1 #\\ 1 #@ 1 #bitShift: 1 #// 1 #bitAnd: 1 #bitOr: 1 #at: 1 #at:put: 2 #size 0 #next 0 #nextPut: 1 #atEnd 0 #== 1 #codAClass 0 #blockCopy: 1 #value 0 #value: 1 #do: 1 #new 0 #new: 1 #x 0 #y 0 ).
	"An array of the 255 Characters in ascii order."
	newArray
		at: 25
		put: ((0 to: 255)
				collect: [:ascii | Character value: ascii]).
	newArray at: 26 put: #mustBeBoolean.
	newArray at: 27 put: ByteArray.
	newArray at: 28 put: Process.
	"An array of up to 31 classes whose instances will have
	compact headers"
	newArray at: 29 put: self compactClassesArray.
	newArray
		at: 30
		put: (self specialObjectsArray at: 30).
	"(delay Semaphore)"
	newArray
		at: 31
		put: (self specialObjectsArray at: 31).
	"(user interrupt Semaphore)"
	"Prototype instances that can be copied for fast initialization"
	newArray
		at: 32
		put: (Float new: 2).
	newArray
		at: 33
		put: (LargePositiveInteger new: 4).
	newArray at: 34 put: Point new.
	newArray at: 35 put: #cannotInterpret:.
	"Note: This must be fixed once we start using context
	prototypes"
	newArray
		at: 36
		put: (self specialObjectsArray at: 36).
	"(MethodContext new: CompiledMethod fullFrameSize)."
	newArray at: 37 put: nil.
	newArray
		at: 38
		put: (self specialObjectsArray at: 38).
	"(BlockContext new: CompiledMethod fullFrameSize)."
	newArray at: 39 put: Array new.
	"array of objects referred to by external code"
	newArray at: 40 put: PseudoContext.
	newArray at: 41 put: TranslatedMethod.
	"finalization Semaphore"
	newArray
		at: 42
		put: ((self specialObjectsArray at: 42)
				ifNil: [Semaphore new]).
	newArray at: 43 put: LargeNegativeInteger.
	"External objects for callout.
	Note: Written so that one can actually completely remove the
	FFI."
	newArray
		at: 44
		put: (self
				at: #ExternalAddress
				ifAbsent: []).
	newArray
		at: 45
		put: (self
				at: #ExternalStructure
				ifAbsent: []).
	newArray
		at: 46
		put: (self
				at: #ExternalData
				ifAbsent: []).
	newArray
		at: 47
		put: (self
				at: #ExternalFunction
				ifAbsent: []).
	newArray
		at: 48
		put: (self
				at: #ExternalLibrary
				ifAbsent: []).
	newArray at: 49 put: #aboutToReturn:through:.
	newArray at: 50 put: #run:with:in:.
	"Now replace the interpreter's reference in one atomic
	operation"
	self specialObjectsArray become: newArray! !

Message subclass: #CodAMessage
	instanceVariableNames: 'from to'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodA-Kernel'!

!CodAMessage class methodsFor: 'as yet unclassified' stamp: 'mab 1/28/2008 02:47'!
from: normalMessage
	^ self new
		setSelector: normalMessage selector arguments: normalMessage arguments! !

!CodAMessage methodsFor: 'accessing' stamp: 'mab 1/28/2008 02:41'!
from
	"Answer the value of from"

	^ from! !

!CodAMessage methodsFor: 'accessing' stamp: 'mab 1/28/2008 02:41'!
from: anObject
	"Set the value of from"

	from := anObject! !

!CodAMessage methodsFor: 'accessing' stamp: 'mab 1/28/2008 02:41'!
to
	"Answer the value of to"

	^ to! !

!CodAMessage methodsFor: 'accessing' stamp: 'mab 1/28/2008 02:41'!
to: anObject
	"Set the value of to"

	to := anObject! !

ProtoObject subclass: #CodAAnonymClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodA-Kernel'!

CodAAnonymClass class
	instanceVariableNames: 'meta'!

CodAAnonymClass class
	instanceVariableNames: 'meta'!

!CodAAnonymClass class methodsFor: 'as yet unclassified' stamp: 'mab 1/31/2008 17:28'!
compileExtendedInstVarAccessors
	self compileSilently: 'meta
		^ codAMeta' classified: Categorizer allCategory.
	self compileSilently: 'meta: val
	codAMeta := val' classified: Categorizer allCategory.
	self compileSilently: 'codAExtension
	^ codAExtension ifNil: [ codAExtension := Dictionary new ]' classified: Categorizer allCategory.
	self compileSilently: 'codAExtension: val
	codAExtension := val' classified: Categorizer allCategory.! !

!CodAAnonymClass class methodsFor: 'as yet unclassified' stamp: 'mab 1/28/2008 11:16'!
doesNotUnderstand: aMessage
	^ self meta perform: aMessage selector withArguments: aMessage arguments.! !

!CodAAnonymClass class methodsFor: 'as yet unclassified' stamp: 'je 1/18/2008 19:05'!
meta
	^meta! !

!CodAAnonymClass class methodsFor: 'as yet unclassified' stamp: 'je 1/18/2008 19:05'!
meta: anObject
	meta := anObject! !

!CodAAnonymClass class methodsFor: 'as yet unclassified' stamp: 'mab 1/22/2008 11:24'!
withArgs: argArray executeMethod: compiledMethod
	"Execute compiledMethod against the receiver and args in argArray"

	| selector |
	<primitive: 188>
	selector := Symbol new.
	self class addSelectorSilently: selector withMethod: compiledMethod.
	^ [self perform: selector withArguments: argArray]
		ensure: [self class basicRemoveSelector: selector]! !

!CodAAnonymClass methodsFor: 'as yet unclassified' stamp: 'mab 1/27/2008 21:02'!
asCodAObject
	^ self! !

!CodAAnonymClass methodsFor: 'accessing' stamp: 'mab 1/27/2008 21:46'!
baseClass
	^ self meta oldObject class! !

!CodAAnonymClass methodsFor: 'as yet unclassified' stamp: 'je 1/18/2008 17:48'!
class
	^self baseClass! !

!CodAAnonymClass methodsFor: 'as yet unclassified' stamp: 'mab 2/3/2008 17:20'!
codAInstVarAt: anInteger put: anObject 
	"Primitive. Store a value into a fixed variable in the receiver. The 
	numbering of the variables corresponds to the named instance variables. 
	Fail if the index is not an Integer or is not the index of a fixed variable. 
	Answer the value stored as the result. Using this message violates the 
	principle that each object has sovereign control over the storing of 
	values into its instance variables. Essential. See Object documentation 
	whatIsAPrimitive."

	<primitive: 74>
	"Access beyond fixed fields"
	^self basicAt: anInteger - self class instSize put: anObject! !

!CodAAnonymClass methodsFor: 'as yet unclassified' stamp: 'mab 1/28/2008 14:30'!
doesNotUnderstand: aMessage
	| codAMessage |
	codAMessage := CodAMessage from: aMessage.
	codAMessage from: thisContext sender receiver.
	codAMessage to: self.
	^ codAMessage from meta send send: codAMessage for: codAMessage from.
	! !

!CodAAnonymClass methodsFor: 'as yet unclassified' stamp: 'mab 1/27/2008 21:01'!
hasExtendableMeta
	^true! !

!CodAAnonymClass methodsFor: 'as yet unclassified' stamp: 'mab 1/28/2008 16:31'!
perform: aSelector with: aValue
	^ self doesNotUnderstand: (Message new setSelector: aSelector arguments: (Array with: aValue))! !

!CodAAnonymClass methodsFor: 'as yet unclassified' stamp: 'je 1/18/2008 19:27'!
species
	^self baseClass! !

!CodAAnonymClass methodsFor: 'as yet unclassified' stamp: 'mab 1/22/2008 11:24'!
withArgs: argArray executeMethod: compiledMethod
	"Execute compiledMethod against the receiver and args in argArray"

	| selector |
	<primitive: 188>
	selector := Symbol new.
	self class addSelectorSilently: selector withMethod: compiledMethod.
	^ [self perform: selector withArguments: argArray]
		ensure: [self class basicRemoveSelector: selector]! !

ProtoObject subclass: #CodAMessageAccumulator
	instanceVariableNames: 'messageChain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodA-Kernel'!

!CodAMessageAccumulator class methodsFor: 'as yet unclassified' stamp: 'mab 12/5/2007 15:06'!
with: aMessageChain
	^self new instVarAt: #messageChain put: aMessageChain! !

!CodAMessageAccumulator methodsFor: 'as yet unclassified' stamp: 'mab 12/5/2007 15:05'!
doesNotUnderstand: message
	^ CodAMessageAccumulator with: (messageChain ifNil: [OrderedCollection new]), message! !

!CodAMessageAccumulator methodsFor: 'as yet unclassified' stamp: 'mab 12/5/2007 15:08'!
m
	^ messageChain! !

ProtoObject subclass: #CodAMessageBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodA-Kernel'!

!CodAMessageBuilder methodsFor: 'as yet unclassified' stamp: 'mab 12/5/2007 14:33'!
doesNotUnderstand: message
	^ message
	! !

!Class methodsFor: '*CodA' stamp: 'mab 2/4/2008 14:22'!
asExtendableMetaFor: anObject 
	| codAMeta |
	codAMeta := CodAMeta with: CodAAnonymClass.
	codAMeta newAnonymSubclassWithVariables: anObject class allInstVarNames, #('codAMeta' 'codAExtension').
	codAMeta anonymClass compileExtendedInstVarAccessors.
	codAMeta oldObject: (codAMeta switchToAnonymClass: anObject).
	codAMeta oldObject class allInstVarNames doWithIndex: [ :var :index |
		anObject codAInstVarAt: index put: (codAMeta oldObject instVarNamed: var asSymbol)].
	^anObject! !

!Class methodsFor: '*CodA' stamp: 'mab 1/28/2008 01:18'!
at: aSymbol for: anObject
	^ anObject instVarNamed: aSymbol! !

!Class methodsFor: '*CodA' stamp: 'mab 1/28/2008 01:18'!
at: aSymbol put: value for: anObject
	^ anObject instVarNamed: aSymbol put: value! !

!Class methodsFor: '*CodA' stamp: 'mab 11/8/2007 16:14'!
isExtendableMeta
	^false! !

!Class methodsFor: '*CodA' stamp: 'mab 1/27/2008 23:47'!
meta
	^self! !

!Class methodsFor: '*CodA' stamp: 'mab 2/4/2008 15:19'!
methodFor: aMessage for: anObject
	^ self compiledMethodAt: aMessage selector ifAbsent: [
		self superclass 
			ifNotNil: [ ^ self superclass methodFor: aMessage for: anObject ]
			ifNil: [ ^ nil ]].! !

!Class methodsFor: '*CodA' stamp: 'mab 1/28/2008 01:35'!
protocol
	^ self! !

!Class methodsFor: '*CodA' stamp: 'mab 1/28/2008 02:19'!
send
	^ self! !

!Class methodsFor: '*CodA' stamp: 'mab 1/28/2008 14:29'!
send: aMessage for: anObject
	^ aMessage to meta receive receive: aMessage for: aMessage to! !

!Class methodsFor: '*CodA' stamp: 'mab 2/4/2008 16:47'!
slotIdsFor: anObject
	^self instVarNames collect: [:each | each asSymbol ]! !

!Class methodsFor: '*CodA' stamp: 'mab 1/27/2008 23:47'!
state
	^self! !

!CompiledMethod methodsFor: '*CodA' stamp: 'mab 2/4/2008 16:06'!
isPrimitive
	^ self primitive ~= 0 & self isQuick not! !

TestCase subclass: #CodaTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodA-Tests'!

!CodaTests methodsFor: 'as yet unclassified' stamp: 'mab 1/27/2008 22:56'!
testClassMethods
	| obj |
	obj := Object new asCodAObject.
	self assert: (Object services = obj class services).! !

!CodaTests methodsFor: 'as yet unclassified' stamp: 'mab 1/29/2008 11:28'!
testClassStaysTheSameAfterCreatingExtendableMeta
	| instance |
	instance := Object new asCodAObject.
	self assert: instance class == Object.! !

!CodaTests methodsFor: 'as yet unclassified' stamp: 'mab 1/28/2008 18:07'!
testInstancePreservation
	| object |
	object := CodATestObject new asCodAObject.
	object changeSomething.
! !

!CodaTests methodsFor: 'as yet unclassified' stamp: 'mab 1/29/2008 11:31'!
testInstanceStaysTheSameAfterCreatingExtendableMeta
	| instance oldInstance |
	instance := oldInstance := Object new.
	instance asCodAObject.
	self assert: instance == oldInstance.! !

!CodaTests methodsFor: 'as yet unclassified' stamp: 'mab 2/3/2008 16:48'!
testInstanceVariablePreservation
	| obj |
	obj := Morph new.
	obj bounds: (10@10 extent: 100@100).
	obj asCodAObject.
	self assert: (obj instVarNamed: #bounds) = (10@10 extent: 100@100).! !

!CodaTests methodsFor: 'as yet unclassified' stamp: 'mab 12/5/2007 14:41'!
testMessageBuilderBuildsCorrectMessage
	| message |
	message := M b at: 1 put: 68.
	self assert: message arguments = #(1 68).
	self assert: message selector = #at:put:.! !

!CodaTests methodsFor: 'as yet unclassified' stamp: 'mab 1/31/2008 17:44'!
testNumbers
	| number |
	number := 7 wrappedByCodA.
	self assert: (number + 35 = 42).! !

!CodaTests methodsFor: 'as yet unclassified' stamp: 'mab 1/28/2008 02:11'!
testSend
	| anObject |
	anObject := Object new.
	anObject asCodAObject.
	anObject name! !

!CodaTests methodsFor: 'as yet unclassified' stamp: 'mab 1/29/2008 11:30'!
testSubclassesAmountStaysTheSameAfterCreatingExtendableMeta
	| instance countBefore |
	countBefore := Object subclasses size.
	instance := Object new.
	instance asCodAObject.
	self assert: countBefore == Object subclasses size.! !
CodAMeta initialize!
